using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DisplayAnywhere
{
    public partial class Form1 : Form
    {

        Bitmap _imageBitmap;
        EditForm _editForm;
		ImageForm _imageForm;

        #region ¼

        /// <summary>
        /// 幹캯
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Դҳʼ༭ʵ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
			PopulateColumnContentArrayList();
            _editForm = new EditForm();
            _editForm.SetBindingSource(columnContentBindingSource);
			_imageForm = new ImageForm();
			_imageForm.SetBindingSource(columnContentBindingSource);
			if (DisplayManager.GetDisplayMode() == DisplayMode.General)
			{
				columnContentPictureBox.Visible = false;
				columnContentDataGrid.Dock = DockStyle.Fill;
			}
			else
			{
				menuMain.MenuItems.Remove(menuViewImage);
			}
        }

        public void AdjustFormLayout()
        {
            Size gridSize = Size.Empty; ;
            Point pictureBoxLocation = Point.Empty; ;
            Size pictureBoxSize = Size.Empty;
            Point buttonLocation = Point.Empty;
			Size buttonSize = Size.Empty;

			float widthRatio = 0.0F;
			float heightRatio = 0.0F;

			DisplayManager.GetDisplayRatiosByDpi(this, ref widthRatio, ref heightRatio);

			//if (DisplayManager.GetDisplayMode() == DisplayMode.Portrait)
			//{
			//    // 
			//    gridSize = new Size((int)(240 * widthRatio), (int)(140 * heightRatio));
			//    pictureBoxLocation = new Point(3, 145);
			//    pictureBoxSize = new Size(160, 120);
			//    buttonLocation = new Point(165, 195);
			//}
			//else
			//{
			//    // 
			//    gridSize = new Size(200, 188);
			//    pictureBoxLocation = new Point(204, 3);
			//    pictureBoxSize = new Size(115, 100);
			//    buttonLocation = new Point(225, 145);
			//}

            #region ؼ

			if (DisplayManager.GetDisplayMode() == DisplayMode.Portrait)
			{
				// 
				gridSize = new Size((int)(240 * widthRatio), (int)(140 * heightRatio));
				pictureBoxLocation = new Point(3, (int)(145 * heightRatio));
				pictureBoxSize = new Size((int)(160 * widthRatio), (int)(120 * heightRatio));
				buttonLocation = new Point((int)(165 * widthRatio), (int)(195 * heightRatio));
				buttonSize = new Size((int)(72 * widthRatio), (int)(20 * heightRatio));
			}
			else if (DisplayManager.GetDisplayMode() == DisplayMode.Landscape)
			{
				// 
				gridSize = new Size((int)(200 * widthRatio), (int)(188 * heightRatio));
				pictureBoxLocation = new Point((int)(204 * widthRatio), 3);
				pictureBoxSize = new Size((int)(115 * widthRatio), (int)(100 * heightRatio));
				buttonLocation = new Point((int)(225 * widthRatio), (int)(145 * heightRatio));
				buttonSize = new Size((int)(72 * widthRatio), (int)(20 * heightRatio));
			}

            #endregion

            columnContentDataGrid.Size = gridSize;
            columnContentPictureBox.Location = pictureBoxLocation;
            columnContentPictureBox.Size = pictureBoxSize;
			//editButton.Location = buttonLocation;
			//editButton.Size = buttonSize;
			dataGridTableStyle1.GridColumnStyles["Title"].Width = (int)(100 * widthRatio);
			dataGridTableStyle1.GridColumnStyles["Description"].Width = (int)(100 * widthRatio);
		}

        #endregion

		#region ؼ¼

		/// <summary>
        /// ˳˵
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void menuExit_Click(object sender, EventArgs e)
        {
            Close();
        }

        #endregion

		#region ݹ¼

		/// <summary>
        /// Դݡ
        /// </summary>
        private void PopulateColumnContentArrayList()
        {
			ArrayList al = new ArrayList();
			ColumnContent cc = new ColumnContent();
			cc.Title = "HandyMenu PPCϵMenu";
			cc.Description = "һܽɰճ";
			cc.ImageFileName = "Image001.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "QuodDB걸ݿӦó";
			cc.Description = "ԷĶ塢ӡ༭ݣҲʾбԼݹˡ";
			cc.ImageFileName = "Image002.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "FreeNewsֻϵ RSS Ķ";
			cc.Description = "һпԶ5վšƱϢ...";
			cc.ImageFileName = "Image003.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "Gaxian Tri BallPPCϵĴϷ";
			cc.Description = "ôСŵָλãĺǻ";
			cc.ImageFileName = "Image004.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "Stuntcar Extreme3DɳϷ";
			cc.Description = "ӵжؼģʽ3DɳϷ";
			cc.ImageFileName = "Image005.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "Super Wild Wild WordsPalmϵϷ";
			cc.Description = "200,000ֵֵ䣬кĹϷ...";
			cc.ImageFileName = "Image006.JPG";
			al.Add(cc);
			cc = new ColumnContent();
			cc.Title = "Papyrusնǿʱ";
			cc.Description = "Papyrus ṩõĽ棬԰š";
			cc.ImageFileName = "Image007.JPG";
			al.Add(cc);
			columnContentBindingSource.DataSource = al;
        }

        /// <summary>
        /// ǰ¼仯ʱʾͼƬ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void columnContentBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            if (_imageBitmap != null)
            {
                _imageBitmap.Dispose();
            }

			ColumnContent cc = GetCurrentColumnContent();
            string imagePath = Path.Combine(GetExecutingAssemblyFolder(), cc.ImageFileName);
            _imageBitmap = new Bitmap(imagePath);
            columnContentPictureBox.Image = _imageBitmap;
        }

        /// <summary>
		/// ȡõǰʾĿݡ
        /// </summary>
        /// <returns></returns>
		private ColumnContent GetCurrentColumnContent()
        {
			return (ColumnContent)columnContentBindingSource.Current;
        }

        /// <summary>
        /// ȡóļơ
        /// </summary>
        /// <returns></returns>
        private string GetExecutingAssemblyFolder()
        {
            string folderName =
                System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            return folderName;
        }

#endregion

        private void editButton_Click(object sender, EventArgs e)
        {
            _editForm.ShowDialog();
        }

		private void Form1_Resize(object sender, EventArgs e)
		{
			AdjustFormLayout();
		}

		private void menuEdit_Click(object sender, EventArgs e)
		{
			_editForm.ShowDialog();
		}

		private void menuViewImage_Click(object sender, EventArgs e)
		{
			_imageForm.ShowDialog();
		}



 

    }
}