using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DisplayAnywhere
{
    public partial class ImageForm : Form
    {
        public ImageForm()
        {
            InitializeComponent();
        }

        private void menuDone_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

        public void SetBindingSource(BindingSource bindingSource)
        {
            _bindingSource = bindingSource;
            _bindingSource.CurrentChanged += new EventHandler(_bindingSource_CurrentChanged);
            DisplayCurrentImage();
        }

        void _bindingSource_CurrentChanged(object sender, EventArgs e)
        {
            DisplayCurrentImage();
        }

        void DisplayCurrentImage()
        {
            if (_imageBitmap != null)
            {
                _imageBitmap.Dispose();
            }

			ColumnContent cc = GetCurrentColumnContent();
            string imagePath = Path.Combine(GetExecutingAssemblyFolder(), cc.ImageFileName);
            _imageBitmap = new Bitmap(imagePath);
            columnContentPictureBox.Image = _imageBitmap;
        }

        Bitmap _imageBitmap;
        BindingSource _bindingSource;

		/// <summary>
		/// ȡõǰʾColumnContent
		/// </summary>
		/// <returns></returns>
		private ColumnContent GetCurrentColumnContent()
		{
			return (ColumnContent)_bindingSource.Current;
		}

        /// <summary>
        /// Get the folder name where the program was loaded from
        /// </summary>
        /// <returns></returns>
        private string GetExecutingAssemblyFolder()
        {
            string folderName =
                System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase);
            return folderName;
        }

    }
}